
// Copyright (c) 1994 Jeff Weisberg
// University of Rochester
//      Dept. of Electrical Engineering
//      Dept. of Neurology, C.E.P.
//
// see the file "License"
 
#ifdef RCSID
static const char *const rcsid
= "@(#)$Id: file.cc,v 1.24 95/01/21 05:11:32 weisberg Exp Locker: weisberg $";
#endif

// Optimization: Off

#include <rdb.h>
#include <info.h>
#include <stdio.h>
#include <fstream.h>

#include <unistd.h>


extern Patient **patients_a;
extern int num_patients;
extern int authorized;

void arcv(FILE *out){
	int i=0;
	FILE *ar;
	
	if(authorized){
		ar = popen("mri-arcv", "w");
		for(i=0; i<num_patients; i++){
			patients_a[i]->arcv(ar);
		}
		fprintf(ar, "==\n");
		fflush(ar);
		if(pclose(ar) & 0xFF)
			fprintf(out, "ERROR arcv failed\n");
		else		
			fprintf(out, "OK\n");
	}else	
		fprintf(out, "ERROR not authorized\n");
	fflush(out);
}

void Patient::arcv(FILE *ar){
	int i;

	if( markf){
		fprintf(ar, "PP %s\n", pid);
		fprintf(ar, "PD %s\n", dir);
		fprintf(ar, "PN %s\n", name);
		fprintf(ar, "PH %s\n", hosp);
		fprintf(ar, "PS %d\n", sex);
		fprintf(ar, "PA %d\n", age);
		fprintf(ar, "PW %d\n", weight);
		fprintf(ar, "PE %d\n", num_exams);
		fprintf(ar, "--\n");
		fflush(ar);
	}else{
		for(i=0; i<num_exams; i++){
			exams[i]->arcv(ar);
		}
	}
}

void Exam::arcv(FILE *ar){
	int i;

	// GYRUS serial # 437E0518
	// part # 600-3432-01
	
	if( markf){
		fprintf(ar, "EN %s\n", name);
		fprintf(ar, "ED %s\n", dir);
		fprintf(ar, "EA %s\n", date);
		fprintf(ar, "EC %s\n", desc);
		fprintf(ar, "ES %d\n", num_series);
		fprintf(ar, "PP %s\n", back->pid);
		fprintf(ar, "PN %s\n", back->name);
		fprintf(ar, "--\n");
		fflush(ar);
	}else{
		for(i=0; i<num_series; i++){
			series[i]->arcv(ar);
		}
	}
}

void Series::arcv(FILE *ar){
	int i;

	if( markf){
		fprintf(ar, "SN %s\n", name);
		fprintf(ar, "SD %s\n", dir);
		fprintf(ar, "SA %s\n", date);
		fprintf(ar, "SC %s\n", desc);
		fprintf(ar, "SP %s\n", proto);
		fprintf(ar, "SI %d\n", num_images);
		fprintf(ar, "EN %s\n", back->name);
		fprintf(ar, "EC %s\n", back->desc);
		fprintf(ar, "PP %s\n", back->back->pid);
		fprintf(ar, "PN %s\n", back->back->name);
		fprintf(ar, "--\n");
		fflush(ar);
	}else{
		for(i=0; i<num_images; i++){
			images[i]->arcv(ar);
		}
	}
}

void Image::arcv(FILE *ar){
	int i;

	if( markf){
		fprintf(ar, "IN %s\n", name);
		fprintf(ar, "ID %s\n", dir);
		fprintf(ar, "SN %s\n", back->name);
		fprintf(ar, "SC %s\n", back->desc);
		fprintf(ar, "SD %s\n", back->date);
		fprintf(ar, "SP %s\n", back->proto);
		fprintf(ar, "EN %s\n", back->back->name);
		fprintf(ar, "EC %s\n", back->back->desc);
		fprintf(ar, "PP %s\n", back->back->back->pid);
		fprintf(ar, "PN %s\n", back->back->back->name);
		fprintf(ar, "--\n");
		fflush(ar);
	}else{
		;
	}
}



