
// Copyright (c) 1995 Jeff Weisberg
// University of Rochester
//      Dept. of Electrical Engineering
//      Dept. of Neurology, C.E.P.
//
// see the file "License"
 
#ifdef RCSID
static const char *const rcsid
= "@(#)$Id$";
#endif

// Optimization: None


#include <rdb.h>
#include <info.h>

#include <ctype.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <signal.h>
#include <sys/time.h>
#include <fstream.h>

extern int authorized;
extern char *rawdir;

struct AuthData {
	AuthData *next;
	char *word;
	int n;
};

static AuthData *auth_data=0;
static int auth_length;


void auth_init(void){
	FILE *fp;
	char fn[8192];
	char buf[8192];
	int n = 0;

	sprintf(fn, "%s/.auth", rawdir);
	fp = fopen( fn, "r");

	while(! feof(fp)){
		AuthData *newone = new AuthData;
		fgets(buf, sizeof(buf), fp);

		if(buf[strlen(buf)-1]=='\n') buf[strlen(buf)-1] = 0;
		newone->word = strdup( buf );
		newone->n = n++;

		newone->next = auth_data;
		auth_data = newone;
	}

	auth_length = n;
	srandom( time(0) * getpid() );

}

void auth(FILE *in, FILE *out, char *txt){
	int io, n0, n1, no;
	int i;
	AuthData *ad = auth_data;
	char buf[8192];
	
	kill(getppid() ,SIGUSR2);	// update parent random seed

	io = (random()&0xFFF) % auth_length;
	n0 = random() & 0xFFF;
	n1 = random() & 0xFFF;
	no = (io * n0 + n1) % auth_length;

	// find initial word
	while(ad->n != io)
		ad = ad->next;

	// send challenge
	fprintf(out, "%s %d %d\n", ad->word, n0, n1);
	fflush(out);

	// find proper response
	ad = auth_data;
	while(ad->n != no)
		ad = ad->next;

	// cerr << "Expecting: " << ad->word << endl;
	
	// get response, strip trailing nl
	fgets(buf, sizeof(buf), in);
	for(i=0; buf[i]; i++)
		if( buf[i]=='\n' || buf[i]=='\r'){
			buf[i] = 0;
			break;
		}
	
	if(! strcmp(ad->word, buf)){
		fprintf(out, "OK\n");
		authorized = 1;
	}else{
		fprintf(out, "ERROR\n");
		authorized = 0;
		// cerr << "Got: " << buf << endl;
	}
	fflush(out);
}

