
// Copyright (c) 1994 Jeff Weisberg
// University of Rochester
//      Dept. of Electrical Engineering
//      Dept. of Neurology, C.E.P.
//
// see the file "License"
 
#ifdef RCSID
static const char *const rcsid
= "@(#)$Id: file.cc,v 1.24 95/01/21 05:11:32 weisberg Exp Locker: weisberg $";
#endif

// Optimization: Off

#include <rdb.h>
#include <info.h>
#include <stdio.h>
#include <fstream.h>

#include <unistd.h>
#include <sys/wait.h>


extern Patient **patients_a;
extern int num_patients;
extern int authorized;



void remove(char *name){

	if(! fork()){
		execl("/bin/rm", "rm", "-rf", name, (char*)0);
	}else{
		wait(0);
	}
}
	
void dele(FILE *out){
	int i=0;

	if(authorized){
		for(i=0; i<num_patients; i++){
			patients_a[i]->dele();
		}
		fprintf(out, "OK\n");
	}else
		fprintf(out, "ERROR not authorized\n");
	fflush(out);
}

void Patient::dele(void){
	int i;

	if( markf){
		remove(dir);
		markf = 0;
	}else{
		for(i=0; i<num_exams; i++){
			exams[i]->dele();
		}
	}
}

void Exam::dele(void){
	int i;

	if( markf){
		remove(dir);
		markf = 0;
	}else{
		for(i=0; i<num_series; i++){
			series[i]->dele();
		}
	}
}

void Series::dele(void){
	int i;

	if( markf){
		remove(dir);
		markf = 0;
	}else{
		for(i=0; i<num_images; i++){
			images[i]->dele();
		}
	}
}

void Image::dele(void){
	int i;
	
	if( markf){
		remove(dir);
		markf = 0;
	}else{
		;
	}
}



