
// Copyright (c) 1995 Jeff Weisberg
// University of Rochester
//      Dept. of Electrical Engineering
//      Dept. of Neurology, C.E.P.
//
// see the file "License"
 
#ifdef RCSID
static const char *const rcsid
= "@(#)$Id$";
#endif

// Optimization: None


#include <rdb.h>
#include <info.h>

#include <ctype.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>


extern Patient **patients_a;
extern int num_patients;

void info(FILE *out, char *txt){
	int i=0,n=0;
	char ntxt[256];
	int tl=strlen(txt);
	int num;
	
	while( n<tl && isspace(txt[n]))
		n++;
	while( n<tl && isdigit(txt[n]))
		ntxt[i++] = txt[n++];
	ntxt[i] = 0;

	if(i){
		Patient *pt;
		num = atoi( ntxt );
		pt = find( num );
		if( pt)
			pt->info(out, txt + n);
		else
			fprintf(out, "ERROR no such patient %s\n", ntxt);
	}else{
		fprintf(out, "ERROR patient unspecified\n");
	}
	
	fflush(out);
}

void Patient::info(FILE *out, char *txt) const {
	int i=0,n=0;
	char ntxt[256];
	int tl=strlen(txt);
	int nm;
	
	while( n<tl && isspace(txt[n]))
		n++;
	while( n<tl && isdigit(txt[n]))
		ntxt[i++] = txt[n++];
	ntxt[i] = 0;

	if(i){
		Exam *ex;
		nm = atoi( ntxt );
		ex = find( nm );
		if( ex)
			ex->info(out, txt + n);
		else
			fprintf(out, "ERROR no such exam %s\n", ntxt);
	}else{
		fprintf(out, "OK (\n");
		fprintf(out, "%s\n", dir);
		fprintf(out, "%s\n", name);
		fprintf(out, "%s\n", hosp);
		fprintf(out, "%d\n", sex);
		fprintf(out, "%d\n", age);
		fprintf(out, "%d\n", weight);
		fprintf(out, "%d\n", num_exams);

		fprintf(out, ")\n");
	}
	
	fflush(out);
}

void Exam::info(FILE *out, char *txt) const {
	int i=0,n=0;
	char ntxt[256];
	int tl=strlen(txt);
	int nm;
	
	while( n<tl && isspace(txt[n]))
		n++;
	while( n<tl && isdigit(txt[n]))
		ntxt[i++] = txt[n++];
	ntxt[i] = 0;

	if(i){
		Series *se;
		nm = atoi( ntxt );
		se = find( nm );
		if( se)
			se->info(out, txt + n);
		else
			fprintf(out, "ERROR no such series %s\n", ntxt);
	}else{
		fprintf(out, "OK (\n");
		fprintf(out, "%s\n", dir);
		fprintf(out, "%s\n", date);
		fprintf(out, "%s\n", desc);
		fprintf(out, "%d\n", num_series);

		fprintf(out, ")\n");
	}
	
	fflush(out);
}

void Series::info(FILE *out, char *txt) const {
	int i=0,n=0;
	char ntxt[256];
	int tl=strlen(txt);
	int nm;
	
	while( n<tl && isspace(txt[n]))
		n++;
	while( n<tl && isdigit(txt[n]))
		ntxt[i++] = txt[n++];
	ntxt[i] = 0;

	if(i){
		Image *im;
		nm = atoi( ntxt );
		im = find( nm );
		if( im)
			im->info(out, txt + n);
		else
			fprintf(out, "ERROR no such image %s\n", ntxt);
	}else{
		fprintf(out, "OK (\n");
		fprintf(out, "%s\n", dir);
		fprintf(out, "%s\n", date);
		fprintf(out, "%s\n", desc);
		fprintf(out, "%s\n", proto);
		fprintf(out, "%d\n", num_images);

		fprintf(out, ")\n");
	}
	
	fflush(out);
}

void Image::info(FILE *out, char *txt) const {

	fprintf(out, "OK (\n");
	fprintf(out, "%s.RDB\n", dir);
	fprintf(out, ")\n");
	fflush(out);
}
