

#include <stdio.h>

#define STR_LEN		256
#define DIR_LEN		512


class Patient;
class Exam;
class Series;
class Image;

void create_db(char*);
void info(FILE*, char*);
void list(FILE*, char*);
void mark(FILE*, char*);
Patient *find(int);

class Image {
public:
	int flag, markf;
	
	char name[ STR_LEN ];
	char dir [ DIR_LEN ];
	int num;
	int xdim, ydim;
	float thick, xfov, yfov;

	Image *next;
	Series *back;

	Image(){ flag = markf = 0; next = 0; }
	int learn(void);
	void info(FILE*, char*) const;
	void mark(FILE*, char*);
	void dele(void);
	void arcv(FILE*);
	void senddata(void);

};

class Series {
public:
	int flag, markf;
	
	char name[ STR_LEN ];
	int num;
	char desc[ STR_LEN ];
	char date[ STR_LEN ];
	char plane[ STR_LEN];
	char proto[ STR_LEN ];
	char dir [ DIR_LEN ];

	int num_images;
	Image **images;
	Series *next;
	Exam *back;

	Series() { flag = num_images = markf = 0; next = 0; }
	~Series(){ for(int i=0;i<num_images;i++) delete images[i]; delete [] images; }
	int learn(void);
	Image *find(int) const;
	void info(FILE*, char*) const;
	void list(FILE*, char*) const;
	void mark(FILE*, char*);
	void dele(void);
	void arcv(FILE*);

};

class Exam {
public:
	int flag, markf;
	
	char name[ STR_LEN ];
	int num;
	char desc[ STR_LEN ];
	char date[ STR_LEN ];
	char dir [ DIR_LEN ];

	int num_series;
	Series **series;
	Exam *next;
	Patient *back;

	Exam() { flag = num_series = markf = 0; next = 0; }
	~Exam(){ for(int i=0;i<num_series;i++) delete series[i]; delete [] series; }
	int learn(void);
	Series *find(int) const;
	void info(FILE*, char*) const;
	void list(FILE*, char*) const;
	void mark(FILE*, char*);
	void dele(void);
	void arcv(FILE*);

};

class Patient {
public:
	int flag, markf;
	
	char name[ STR_LEN ];
	int num;
	char pid [ STR_LEN ];
	char dir [ DIR_LEN ];
	char hosp[ STR_LEN ];

	char sex;
	int age, weight;

	int num_exams;
	Exam **exams;
	Patient *next;

	Patient() { flag = num_exams = markf = 0; next = 0; }
	~Patient(){ for(int i=0;i<num_exams;i++) delete exams[i]; delete [] exams; }
	int learn(void);
	Exam *find(int) const;
	void info(FILE*, char*) const;
	void list(FILE*, char*) const;
	void mark(FILE*, char*);
	void dele(void);
	void arcv(FILE*);

};

