
// Copyright (c) 1995 Jeff Weisberg
// University of Rochester
//      Dept. of Electrical Engineering
//      Dept. of Neurology, C.E.P.
//
// see the file "License"
 
#ifdef RCSID
static const char *const rcsid
= "@(#)$Id$";
#endif

// Optimization: None


#include <rdb.h>
#include <info.h>

#include <ctype.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>


extern Patient **patients_a;
extern int num_patients;

void list(FILE *out, char *txt){
	int i=0,n=0;
	char ntxt[256];
	int tl=strlen(txt);
	int num;
	
	while( n<tl && isspace(txt[n]))
		n++;
	while( n<tl && isdigit(txt[n]))
		ntxt[i++] = txt[n++];
	ntxt[i] = 0;

	if(i){
		Patient *pt;
		num = atoi( ntxt );
		pt = find( num );
		if( pt)
			pt->list(out, txt + n);
		else
			fprintf(out, "ERROR no such patient %s\n", ntxt);
	}else{
		fprintf(out, "OK %d (\n", num_patients);

		for(i=0; i<num_patients; i++){
			fprintf(out, "%s\n", patients_a[i]->pid);
		}
		fprintf(out, ")\n");
	}
	
	fflush(out);
}

void Patient::list(FILE *out, char *txt) const {
	int i=0,n=0;
	char ntxt[256];
	int tl=strlen(txt);
	int nm;
	
	while( n<tl && isspace(txt[n]))
		n++;
	while( n<tl && isdigit(txt[n]))
		ntxt[i++] = txt[n++];
	ntxt[i] = 0;

	if(i){
		Exam *ex;
		nm = atoi( ntxt );
		ex = find( nm );
		if( ex)
			ex->list(out, txt + n);
		else
			fprintf(out, "ERROR no such exam %s\n", ntxt);
	}else{
		fprintf(out, "OK %d (\n", num_exams);

		for(i=0; i<num_exams; i++){
			fprintf(out, "%s\n", exams[i]->name);
		}
		fprintf(out, ")\n");
	}
	
	fflush(out);
}

void Exam::list(FILE *out, char *txt) const {
	int i=0,n=0;
	char ntxt[256];
	int tl=strlen(txt);
	int nm;
	
	while( n<tl && isspace(txt[n]))
		n++;
	while( n<tl && isdigit(txt[n]))
		ntxt[i++] = txt[n++];
	ntxt[i] = 0;

	if(i){
		Series *se;
		nm = atoi( ntxt );
		se = find( nm );
		if( se)
			se->list(out, txt + n);
		else
			fprintf(out, "ERROR no such series %s\n", ntxt);
	}else{
		fprintf(out, "OK %d (\n", num_series);

		for(i=0; i<num_series; i++){
			fprintf(out, "%s\n", series[i]->name);
		}
		fprintf(out, ")\n");
	}
	
	fflush(out);
}


void Series::list(FILE *out, char *txt) const {
	int i=0,n=0;
	

	fprintf(out, "OK %d (\n", num_images);
	
	for(i=0; i<num_images; i++){
		fprintf(out, "%s\n", images[i]->name);
	}
	fprintf(out, ")\n");
	
	fflush(out);
}



