
// Copyright (c) 1995 Jeff Weisberg
// University of Rochester
//      Dept. of Electrical Engineering
//      Dept. of Neurology, C.E.P.
//
// see the file "License"
 
#ifdef RCSID
static const char *const rcsid
= "@(#)$Id$";
#endif

// Optimization: None

#include <rdb.h>
#include <info.h>
#include <fstream.h>
#include <signal.h>
#include <unistd.h>
#include <sys/wait.h>

extern "C" void update_db(void);

extern void auth_init(void);

int main(int argc, char**argv){
	int fd;

	if( argc <2)
		exit(-1);

	create_db( argv[1] );
	cerr << "db loaded. waiting." << endl;

#ifndef DEBUG	
	// hop into background and daemonize
	if( fork())
		_exit(0);

	cerr << "Pid: " << getpid() << endl;
	ofstream("/var/tmp/mri-rdbs.pid") << getpid() << endl;
	
	setsid();
#endif	
	init_sig_hs();
	auth_init();
	fd = create_server();
	server_loop( fd );

	// Not Reached
	return 0;
}

extern "C" void reap(void){

	while(! waitpid(-1,0,WNOHANG));
}

// auth is done in children, we want children to have good
// non-correlated random numbers
extern "C" void auth_next(void){
	int i, n=random()&0xF;

	for(i=0; i<n; i++)
		random();
}
	
void init_sig_hs(void){

	signal(SIGCHLD, (void(*)(int,...))reap);
	signal(SIGUSR1, (void(*)(int,...))update_db);
	signal(SIGUSR2, (void(*)(int,...))auth_next);

}

	
