
// Copyright (c) 1995 Jeff Weisberg
// University of Rochester
//      Dept. of Electrical Engineering
//      Dept. of Neurology, C.E.P.
//
// see the file "License"
 
#ifdef RCSID
static const char *const rcsid
= "@(#)$Id$";
#endif

// Optimization: None

#define DEBUG

#include <rdb.h>
#include <info.h>

#include <ctype.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>


extern Patient **patients_a;
extern int num_patients;
extern int authorized;

void mark(FILE *out, char *txt){
	int i=0,n=0;
	char ntxt[256];
	int tl=strlen(txt);
	int num;
	
	while( n<tl && isspace(txt[n]))
		n++;
	while( n<tl && isdigit(txt[n]))
		ntxt[i++] = txt[n++];
	ntxt[i] = 0;

	if(i){
		Patient *pt;
		num = atoi( ntxt );
		pt = find( num );
		if( pt)
			pt->mark(out, txt + n);
		else
			fprintf(out, "ERROR no such patient %s\n", ntxt);
	}else{
		fprintf(out, "ERROR patient unspecified\n");
	}
	
	fflush(out);
}



void Patient::mark(FILE *out, char *txt) {
	int i=0,n=0;
	char ntxt[256];
	int tl=strlen(txt);
	int nm;
	
	while( n<tl && isspace(txt[n]))
		n++;
	while( n<tl && isdigit(txt[n]))
		ntxt[i++] = txt[n++];
	ntxt[i] = 0;

	if(i){
		Exam *ex;
		nm = atoi( ntxt );
		ex = find( nm );
		if( ex)
			ex->mark(out, txt + n);
		else
			fprintf(out, "ERROR no such exam %s\n", ntxt);
	}else if(authorized){
		markf = 1;
		fprintf(out, "OK\n");
	}else{
		fprintf(out, "ERROR not authorized\n");
	}
	
	fflush(out);
}

void Exam::mark(FILE *out, char *txt) {
	int i=0,n=0;
	char ntxt[256];
	int tl=strlen(txt);
	int nm;
	
	while( n<tl && isspace(txt[n]))
		n++;
	while( n<tl && isdigit(txt[n]))
		ntxt[i++] = txt[n++];
	ntxt[i] = 0;

	if(i){
		Series *se;
		nm = atoi( ntxt );
		se = find( nm );
		if( se)
			se->mark(out, txt + n);
		else
			fprintf(out, "ERROR no such exam %s\n", ntxt);
	}else if(authorized){
		markf = 1;
		fprintf(out, "OK\n");
	}else{
		fprintf(out, "ERROR not authorized\n");
	}
	
	fflush(out);
}

void Series::mark(FILE *out, char *txt) {
	int i=0,n=0;
	char ntxt[256];
	int tl=strlen(txt);
	int nm;
	
	while( n<tl && isspace(txt[n]))
		n++;
	while( n<tl && isdigit(txt[n]))
		ntxt[i++] = txt[n++];
	ntxt[i] = 0;

	if(i){
		Image *im;
		nm = atoi( ntxt );
		im = find( nm );
		if( im)
			im->mark(out, txt + n);
		else
			fprintf(out, "ERROR no such exam %s\n", ntxt);
	}else if(authorized){
		markf = 1;
		fprintf(out, "OK\n");
	}else{
		fprintf(out, "ERROR not authorized\n");
	}
	
	fflush(out);
}

void Image::mark(FILE *out, char *txt) {
	
	if(authorized){
		markf = 1;
		fprintf(out, "OK\n");
	}else{
		fprintf(out, "ERROR not authorized\n");
	}
	
	fflush(out);
}

